package meerkat.voting;

import meerkat.protobuf.Voting.BallotAnswer;
import meerkat.protobuf.Voting.BallotAnswerTranslationTable;
import meerkat.protobuf.Voting.BallotQuestion;
import meerkat.protobuf.Voting.BallotSecrets;
import meerkat.protobuf.Voting.BoothParams;
import meerkat.protobuf.Voting.ElectionParams;
import meerkat.protobuf.Voting.PlaintextBallot;
import meerkat.protobuf.Crypto.EncryptionPublicKey;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.List;



public class VotingBoothToy implements VotingBooth, Runnable {

	//private ElectionParams m_electionParams;		
	private EncryptionPublicKey m_ballotEncryptionKey;
	private List<BallotQuestion> l_questions;
	private BallotQuestion a_questions[];
	private BallotAnswer a_answers[];
	private BallotAnswerTranslationTable m_answerTranslationTable;
	
	private BoothParams m_boothParams;
	private VotingBooth.UI m_ui;
	
	
	public static void main (String[] args)
	{
		VotingBoothToy vbController = new VotingBoothToy ();
		VotingBoothToyConsoleUI ui = new VotingBoothToyConsoleUI();

		vbController.registerUI (ui);
		ui.registerVBController(vbController);
		
		BoothParams boothParams = new BoothParams();
		ElectionParams electionParams = new ElectionParams();
		
		vbController.init(electionParams, boothParams);
		
		Thread controllerThread = new Thread(new VotingBoothToy ());
		Thread uiThread = new Thread(ui);

		controllerThread.start();
		uiThread.start();
		
	}
	
	public VotingBoothToy () {
	}
	
	public void registerUI (UI ui) {
		m_ui = ui;
	}
	
	public void run () {
		
	}
	
	/* (non-Javadoc)
	 * @see meerkat.voting.VotingBooth#init(meerkat.protobuf.Voting.ElectionParams, meerkat.protobuf.Voting.BoothParams)
	 */
	@Override
	public void init(ElectionParams globalParams, BoothParams boothParams) {
		System.err.println ("debug VB: init.");
		this.m_ballotEncryptionKey = globalParams.getBallotEncryptionKey();
		this.l_questions =  globalParams.getQuestionsList();
		
		this.m_answerTranslationTable = globalParams.getAnswerTranslationTable();

		this.m_boothParams = boothParams;

	}

	public void registerVBUI (VotingBooth.UI ui)
	{
		m_ui = ui;
	}
	/* (non-Javadoc)
	 * @see meerkat.voting.VotingBooth#submitBallot(meerkat.protobuf.Voting.PlaintextBallot)
	 */
	@Override
	public void submitBallot(PlaintextBallot ballot) {
		System.err.println ("debug VB: submit ballot.");
		// encryptBallot (PlaintextBallot)

	}

	/* (non-Javadoc)
	 * @see meerkat.voting.VotingBooth#cancelBallot()
	 */
	@Override
	public void cancelBallot() {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see meerkat.voting.VotingBooth#voterCastOrAudit(boolean)
	 */
	@Override
	public void voterCastOrAudit(boolean castVote) {
		// TODO Auto-generated method stub

	}

}



/*

//A ballot question. This is an opaque
//data type that is parsed by the UI to display
//the question.
message BallotQuestion {
 bytes data = 1;
}

//An answer to a specific ballot question.
//The answer is a vector of signed integers,
//to encompass voting schemes such as ranked voting
//and STV.
message BallotAnswer {
 repeated sint64 answer = 1 [packed=true];
}

message PlaintextBallot {
 uint64 serialNumber = 1; // Ballot serial number

 repeated BallotAnswer answers = 2;
}

message BallotSecrets {
 PlaintextBallot plaintext_ballot = 1;

 EncryptionRandomness encryption_randomness = 2;
 RandomnessGenerationProof proof = 3;
}

message BoothParams {
 repeated SignatureVerificationKey pscVerificationKeys = 1;

}

//A table to translate to and from compactly encoded answers
//and their human-understandable counterparts.
//This should be parsable by the UI
message BallotAnswerTranslationTable {
 bytes data = 1;
}

message ElectionParams {
 // TODO: different sets of keys for different roles?
 //repeated SignatureVerificationKey trusteeVerificationKeys = 1;

 // How many trustees must participate in a signature for it to be considered valid.
 //uint32 trusteeSignatureThreshold = 2;

 // The key used to encrypt ballots. The corresponding private key
 // is shared between the trustees.
 EncryptionPublicKey ballotEncryptionKey = 3;

 // Verification keys for valid mixers.
 //repeated SignatureVerificationKey mixerVerificationKeys = 4;

 // How many mixers must participate for the mixing to be considered valid
 //uint32 mixerThreshold = 5;

 // Candidate list (or other question format)
 repeated BallotQuestion questions = 6;

 // Translation table between answers and plaintext encoding
 BallotAnswerTranslationTable answerTranslationTable = 7;

}
*/